#ifndef GENETIC_H
#define GENETIC_H

#include "Population.h"
#include "Individual.h"

/**
 * Author: Thibaut Vidal
 * 
 * This class encompasses all genetic search of HGSADC.
 * 
 */

class Genetic
{
private:

	Params * params;				// Problem parameters
	Split * split;					// Split algorithm
	Population * population;		// Population
	LocalSearch * localSearch;		// Local Search structure
	Mining * mining;				// Mining structure
	Individual * offspring;			// First individual to be used as input for the crossover
	clock_t ticks ;					// Remaining time

	// OX Crossover
	void crossoverOX(Individual * result, Individual * parent1, Individual * parent2);

	#if ACTIVE_SIDE_EXPERIMENTS > 0
		SideExperiments *sideExperiments;
	#endif
public:

    // Running the genetic algorithm until termination criterion
    void run(int maxIter , int maxIterNonProd) ;

	// Constructor
	Genetic(Params * params, Split * split, Population * population, LocalSearch * localSearch, Mining * mining, clock_t ticks);

	// Destructor
	~Genetic(void);
};

#endif
