# Introduction
The official Github repository of the PILS extension of [A Hybrid Genetic Algorithm for Multidepot and Periodic Vehicle Routing Problems (HGSADC)](https://doi.org/10.1287/opre.1120.1048) of Vidal et al. (2012).
# Building

* **Enter** the Program directory: `cd Program`
* **Run** the make command: `make`
* **Run** an example: `./genvrp ../Instances/CVRP/pr01.txt`

# Running

```
Usage:
  genvrp instance_path [options]
Available options:
  -t,            CPU time in seconds (otherwise defaults to 240 seconds for each 100 customers in the instance).
  -sol           File where to output the solution (defaults to the instance 
                    file name prepended with 'sol-').
  -seed          Random seed (defaults to 0).
                 When sets to 0, defines the seed based on the current time
				 Use any other number to have a fixed seed 
				 Important: if seed value is greater than 5, PILS is performed before local search (LS). Otherwise, PILS is performed after LS. Parameter '-pils' should be 1 in both cases.
  -type          Instance format during parsing
					0 => Non-specified, assumes that the first integer in the instance file defines the type
					1 => CMT instances
					2 => Golden instances
					3 => X instances (from Uchoa et al). Same instance format used for Belgian districts by Florian Arnold.
  -veh           Maximum number of vehicles to use.
                    Only relevant for Uchoa et al. instances. In the other 
                    cases this value is read from the instance itself.
				 If not specified, the fleet size is set to a default value
				 computed from the total demand and vehicle capacity  
   -pils	Parameter defining the pattern injection local search (defaults to 0)
					0 => Deactivated 
					1 => Activated before the LS
					2 => Activated after the LS
					3 => Activated before and after the LS
  -?, --help     Prints a help screen.
```

Example #1: `./genvrp ../Instances/CVRP/X-n101-k25.vrp -sol test.txt -t 120 -type 29 -veh 30 -seed 1`

# Output file 

All generated data follow the header below.

**Instance;Seed;n;m;Status-PILS;PhiFreq;PhiSize;Lmax;Pex;Progress(%);Solution-Cost;Vehicles-Used;CPU(s);CPU-LS(s);CPU-Extract(s);CPU-PILS(s);NbExtractions;NbPILS;NbInjectionsTested;NbInjectionsApplied;Pattern-Size-2;Pattern-Size-3;Pattern-Size-4;Pattern-Size-5;Pattern-Size-6;Pattern-Size-7;Pattern-Size-8;Pattern-Size-9;Pattern-Size-10;Routes-Involved-1;Routes-Involved-2;Routes-Involved-3;Routes-Involved-4;Routes-Involved-5;Routes-Involved-6;Routes-Involved-7;Routes-Involved-8;Routes-Involved-9;Routes-Involved-10;Move-Order-2;Move-Order-3;Move-Order-4;Move-Order-5;Move-Order-6;Move-Order-7;Move-Order-8;Move-Order-9;Move-Order-10;Move-Order-11;Move-Order-12;Move-Order-13;Move-Order-14;Move-Order-15;Move-Order-16;Move-Order-17;Move-Order-18;Move-Order-19;Move-Order-20;**

# A script for running all instances
* **Enter** the Experiments directory: `cd Experiments/` 
* **Compile** the source-code and **run** all instances using: `sh exec-all-instances.sh`


# References of all instance sets (in chronological order)
  * **Instance name format: p\*.txt (example: p01.txt)** [reference: Christofides, N., Mingozzi, A., & Toth, P. (1979). The vehicle routing problem. In N. Christofides, A. Mingozzi, P. Toth, & C. Sandi (Eds.), Combined Optimization (pp. 315–338). Chichester, UK: Wiley.]
  * **Instance name format: pr\*.txt (example: pr01.txt)** [reference: Golden, B. L., Wasil, E. A., Kelly, J. P., & Chao, I. M. (1998). The impact of metaheuristics on solving the vehicle routing problem: Algorithms, problem sets, and computational results. In T. G. Crainic & G. Laporte (Eds.), Fleet management and logistics (pp. 33–56). Boston, MA: Kluwer Academic Publishers.]
  * **Instance name format starts with X-n\*-k\*.vrp (example: X-n101-k25.vrp)** [reference: Uchoa, E., Pecin, D., Pessoa, A., Poggi, M., Vidal, T., & Subramanian, A. (2017). New benchmark instances for the Capacitated Vehicle Routing Problem. European Journal of Operational Research, 257(3), 845–858.]
  * **Instance names are Belgium cities (example Antwerp1.txt)** [reference: Arnold, F., Gendreau, M., & Sörensen, K. (2019). Efficiently solving very large-scale routing problems. Computers and Operations Research, 107, 32–42.]
  
Wilcard (\*) stands for an integer number.

  
